<template>
  <div>
    <div class="text-center mb-4">
      <h4>
        <slot />
      </h4>
    </div>

    <div class="flex-center flex-col">
      <button
        class="big-btn mb-4"
        @click="showModal = true"
      >
        Select
      </button>

      <p v-if="selectedRows.length == 0">
        Nobody
      </p>

      <p v-else>
        {{ selectedRows.length }} selected
      </p>

      <ViewRules :rules="rulesWithType" />
    </div>

    <modal v-model="showModal">
      <div class="grid-one p-2">
        <template v-if="ruleNumber > 0">
          <div
            v-for="index of ruleNumber"
            :key="index"
            class="flex items-center"
          >
            <RuleCreator
              v-model="rules[index - 1]"
              :dimensions="dimensions"
              :data="partiallySelectedRows[index - 1]"
            />

            <button
              class="ml-auto cursor-pointer"
              @click="rules.splice(index - 1, 1)"
            >
              <icon
                name="minus"
                scale="2"
              />
            </button>
          </div>
        </template>

        <p v-else>
          No rules yet.
        </p>

        <button
          class="cursor-pointer"
          @click="ruleNumber += 1"
        >
          <icon
            name="plus"
            scale="2"
          />
        </button>

        <div v-if="selectedRows.length > 0">
          {{ selectedRows.length }} rows selected.
        </div>
      </div>

      <vue-good-table
        ref="table_g1"
        :columns="columns"
        class="w-100"
        :rows="selectedRows"
        :pagination-options="{
          enabled: true,
          perPage: 5,
          perPageDropdown: [5, 10, 20],
        }"
      />
    </modal>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Model, Prop, Watch } from 'vue-property-decorator'

import {
  VueGoodTable
} from 'vue-good-table'
import 'vue-good-table/dist/vue-good-table.css'
import 'vue-awesome/icons/plus'
import 'vue-awesome/icons/minus'
import Icon from 'vue-awesome/components/Icon.vue'

import Modal from '@/components/Modal.vue'
import RuleCreator from './ConfigRuleCreator.vue'
import ViewRules from '@/components/ViewRules.vue'

import _ from 'lodash/fp'

const ruleTypes = [
  'inSet',
  'outSet',
  'inInterval',
  'outInterval',
  'lowerThan',
  'greaterThan',
  'contain_themes'
]

const getRuleType = _.compose([
  _.find((key) => (_.includes)(key)(ruleTypes)),
  _.keys])

const hasDescendantTheme = _.memoize(_.compose([_.some, _.startsWith, _.first, _.split(' ')]))
const hasAllThemes = (parentThemes, themes) => _.every((parentTheme) => hasDescendantTheme(parentTheme)(themes))(parentThemes)

const respectsRule = (rule) => (item) => {
  const dimension = rule.dimensionName
  const itemValueForRule = _.get(dimension, item)
  const ruleContent = (code) => _.get(code, rule)

  switch (getRuleType(rule)) {
    case 'inSet':
      return _.includes(itemValueForRule, ruleContent('inSet'))
    case 'outSet':
      return _.negate(_.includes)(itemValueForRule, ruleContent('outSet'))
    case 'inInterval': {
      const [lower, upper] = ruleContent('inInterval')
      return itemValueForRule >= lower && itemValueForRule <= upper
    }
    case 'outInterval': {
      const [lower, upper] = ruleContent('inInterval')
      return itemValueForRule <= lower || itemValueForRule >= upper
    }
    case 'lowerThan': {
      return itemValueForRule <= ruleContent('lowerThan')
    }
    case 'greaterThan': {
      return itemValueForRule >= ruleContent('greaterThan')
    }
    case 'contain_themes': {
      const parentThemes = ruleContent('contain_themes')
      const themes = eval(itemValueForRule)
      return hasAllThemes(parentThemes, themes)
    }
    default:
      return true
  }
}

const filterByRules = _.compose([_.filter, _.overEvery, _.map(respectsRule)])

@Component({
  components: {
    Icon,
    Modal,
    RuleCreator,
    ViewRules,
    VueGoodTable
  }
})
export default class GroupWithRules extends Vue {
  @Model('rules', {
    default () { return [] }
  }) parentScope

  @Prop(Array) rows
  @Prop(Array) columns
  @Prop(Array) dimensions

  rules = this.parentScope
  ruleNumber = this.parentScope.length
  showModal = false

  get selectedRows () {
    return filterByRules(this.rules)(this.rows)
  }

  get partiallySelectedRows () {
    return _.map(
      _.compose([
        (rules) => filterByRules(rules)(this.rows),
        (fn) => fn(this.rules),
        _.take
      ]),
      _.range(0, this.ruleNumber)
    )
  }

  get rulesWithType () {
    return _.zip(this.rules, _.map(getRuleType, this.rules))
  }

  @Watch('parentScope')
  onParentScopeChanged () {
    this.ruleNumber = this.parentScope.length
    this.rules = this.parentScope
  }

  @Watch('rules')
  onRulesChanged () {
    this.$emit('rules', this.rules)
  }
}
</script>
